searchData={"content_type":"text/markdown","items":[{"doc":"Generate codes of ROS 2 message type\n\nBefore generating, specifying message types in config.exs is needed.\n\n```\nconfig :rclex, ros2_message_types: [\"std_msgs/msg/String\"]\n```\n\n> ##","ref":"Mix.Tasks.Rclex.Gen.Msgs.html","title":"mix rclex.gen.msgs","type":"task"},{"doc":"> Be careful, ros2 message type is case sensitive.","ref":"Mix.Tasks.Rclex.Gen.Msgs.html#module-info-info","title":"Info {: .info } - mix rclex.gen.msgs","type":"task"},{"doc":"```\nmix rclex.gen.msgs\n```\n\nThis task assumes that the environment variable `ROS_DISTRO` is set\nand refers to the message types from `/opt/ros/[ROS_DISTRO]/share`.\n\nWe can also specify explicitly as follows\n\n```\nmix rclex.gen.msgs --from /opt/ros/foxy/share\n```","ref":"Mix.Tasks.Rclex.Gen.Msgs.html#module-how-to-generate","title":"How to generate - mix rclex.gen.msgs","type":"task"},{"doc":"```\nmix rclex.gen.msgs --clean\n```","ref":"Mix.Tasks.Rclex.Gen.Msgs.html#module-how-to-clean","title":"How to clean - mix rclex.gen.msgs","type":"task"},{"doc":"Prepare ROS 2 resources under .ros2 directory.\n\n```\nmix rclex.prep.ros2 --arch ARCH\n```\n\nROS 2 resources will be prepared under .ros2.\n\nAn `--arch` option should be specified, option value is `arm64v8`, currently only supported.","ref":"Mix.Tasks.Rclex.Prep.Ros2.html","title":"mix rclex.prep.ros2","type":"task"},{"doc":"specify arch explicitly with `--arch` option\n\n```\nmix rclex.prep.ros2 --arch arm64v8\n```\n\nFor Nerves, `export MIX_TARGET=[TARGET]` is invoked properly, `--arch` option is not needed.\n\n```\nmix rclex.prep.ros2\n```","ref":"Mix.Tasks.Rclex.Prep.Ros2.html#module-examples","title":"Examples - mix rclex.prep.ros2","type":"task"},{"doc":"Defines functions to manage ROS client resources.","ref":"Rclex.html","title":"Rclex","type":"module"},{"doc":"Return a properly initialized allocator with default values.","ref":"Rclex.html#get_default_allocator/0","title":"Rclex.get_default_allocator/0","type":"function"},{"doc":"Initialize Rclex, return initialized context.","ref":"Rclex.html#rclexinit/0","title":"Rclex.rclexinit/0","type":"function"},{"doc":"Shutdown Rclex,\nthis function does not have to be called on exit,\nbut does have to be called making a repeat call to rclexinit.","ref":"Rclex.html#shutdown/1","title":"Rclex.shutdown/1","type":"function"},{"doc":"ユーザのタスク終了入力を受け付けるAPI.\n  0を入力するとchildに渡されたPIDのタスクを終了する","ref":"Rclex.html#waiting_input/2","title":"Rclex.waiting_input/2","type":"function"},{"doc":"Receives job queue and executes queue element in order.\n\n* The execution order can be changed by using the change order function.\n  * change order function receives list(), return list()\n\nUsed by `Rclex.Timer` and `Rclex.Subscriber`.","ref":"Rclex.JobExecutor.html","title":"Rclex.JobExecutor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Rclex.JobExecutor.html#child_spec/1","title":"Rclex.JobExecutor.child_spec/1","type":"function"},{"doc":"","ref":"Rclex.JobExecutor.html#start_link/1","title":"Rclex.JobExecutor.start_link/1","type":"function"},{"doc":"Queue jobs, jobs in the queue are executed when jobs count reached the queue length or over.\n\n* queue length is changeable\n  * if not specified the length to be 1\n\nUsed by `Rclex.Timer` and `Rclex.Subscriber`.","ref":"Rclex.JobQueue.html","title":"Rclex.JobQueue","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Rclex.JobQueue.html#child_spec/1","title":"Rclex.JobQueue.child_spec/1","type":"function"},{"doc":"","ref":"Rclex.JobQueue.html#start_link/1","title":"Rclex.JobQueue.start_link/1","type":"function"},{"doc":"Defines functions which call `Rclex.MsgProt` implementation.","ref":"Rclex.Msg.html","title":"Rclex.Msg","type":"module"},{"doc":"Return reference which refers to initialized msg_type C struct instance.","ref":"Rclex.Msg.html#initialize/1","title":"Rclex.Msg.initialize/1","type":"function"},{"doc":"Return list of reference which refers to initialized msg_type C struct instance.","ref":"Rclex.Msg.html#initialize_msgs/2","title":"Rclex.Msg.initialize_msgs/2","type":"function"},{"doc":"Return msg_type struct loaded with data from C struct instance.","ref":"Rclex.Msg.html#read/2","title":"Rclex.Msg.read/2","type":"function"},{"doc":"Set Elixir struct to C struct instance.","ref":"Rclex.Msg.html#set/3","title":"Rclex.Msg.set/3","type":"function"},{"doc":"Return typesupport reference.","ref":"Rclex.Msg.html#typesupport/1","title":"Rclex.Msg.typesupport/1","type":"function"},{"doc":"Defines protocol which supports arbitrary message types.\nModules implementing this protocol should define relationships between Elixir structure data and C structure data.","ref":"Rclex.MsgProt.html","title":"Rclex.MsgProt","type":"protocol"},{"doc":"Should return reference to C struct instance.","ref":"Rclex.MsgProt.html#initialize/1","title":"Rclex.MsgProt.initialize/1","type":"function"},{"doc":"Should return Elixir struct loaded with data from C struct instance.","ref":"Rclex.MsgProt.html#read/2","title":"Rclex.MsgProt.read/2","type":"function"},{"doc":"Should set Elixir struct to C struct instance.","ref":"Rclex.MsgProt.html#set/2","title":"Rclex.MsgProt.set/2","type":"function"},{"doc":"Should return typesupport reference.","ref":"Rclex.MsgProt.html#typesupport/1","title":"Rclex.MsgProt.typesupport/1","type":"function"},{"doc":"","ref":"Rclex.MsgProt.html#t:t/0","title":"Rclex.MsgProt.t/0","type":"type"},{"doc":"","ref":"Rclex.MsgTypesNif.html","title":"Rclex.MsgTypesNif","type":"module"},{"doc":"Defines functions to assign job, subscribe or publish, to Node.","ref":"Rclex.Node.html","title":"Rclex.Node","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Rclex.Node.html#child_spec/1","title":"Rclex.Node.child_spec/1","type":"function"},{"doc":"Create publisher.","ref":"Rclex.Node.html#create_publisher/3","title":"Rclex.Node.create_publisher/3","type":"function"},{"doc":"* node_identifier: node identifier\n* msg_types: ex) 'StdMsgs.Msg.String'\n* topic_name: topic name, ex) 'test'","ref":"Rclex.Node.html#create_publisher/3-arguments","title":"Arguments - Rclex.Node.create_publisher/3","type":"function"},{"doc":"Create multiple publishers","ref":"Rclex.Node.html#create_publishers/4","title":"Rclex.Node.create_publishers/4","type":"function"},{"doc":"* node_identifier_list: node identifier list\n* msg_types: ex) 'StdMsgs.Msg.String'\n* topic_name: topic name, ex) 'test'\n* type: :single or :multi\n\n#","ref":"Rclex.Node.html#create_publishers/4-arguments","title":"Arguments - Rclex.Node.create_publishers/4","type":"function"},{"doc":"Create multiple publishers to a single topic.\n\n    +------------+                        \n    | publisher  +---------+              \n    +------------+         |              \n                           |              \n    +------------+         |              \n    | publisher  +---------+              \n    +------------+         |     +-------+\n                           +-----+ topic |\n    +------------+         |     +-------+\n    | publisher  +---------+              \n    +------------+         |              \n                           |              \n    +------------+         |              \n    | publisher  +---------+              \n    +------------+                        \n\n#","ref":"Rclex.Node.html#create_publishers/4-type-single","title":"type: :single - Rclex.Node.create_publishers/4","type":"function"},{"doc":"Create one-to-one publishers for multiple topics.\n\n    +------------+               +-------+\n    | publisher  +---------------+ topic |\n    +------------+               +-------+\n                                          \n    +------------+               +-------+\n    | publisher  +---------------+ topic |\n    +------------+               +-------+\n                                          \n    +------------+               +-------+\n    | publisher  +---------------+ topic |\n    +------------+               +-------+\n                                          \n    +------------+               +-------+\n    | publisher  +---------------+ topic |\n    +------------+               +-------+","ref":"Rclex.Node.html#create_publishers/4-type-multi","title":"type: :multi - Rclex.Node.create_publishers/4","type":"function"},{"doc":"Create subscriber.","ref":"Rclex.Node.html#create_subscriber/3","title":"Rclex.Node.create_subscriber/3","type":"function"},{"doc":"* node_identifier: node identifier\n* msg_types: ex) 'StdMsgs.Msg.String'\n* topic_name: topic name, ex) 'test'","ref":"Rclex.Node.html#create_subscriber/3-arguments","title":"Arguments - Rclex.Node.create_subscriber/3","type":"function"},{"doc":"Create multiple subscribers.","ref":"Rclex.Node.html#create_subscribers/4","title":"Rclex.Node.create_subscribers/4","type":"function"},{"doc":"* node_identifier_list: node identifier list\n* msg_types: ex) 'StdMsgs.Msg.String'\n* topic_name: topic name, ex) 'test'\n* type: :single or :multi\n\n#","ref":"Rclex.Node.html#create_subscribers/4-arguments","title":"Arguments - Rclex.Node.create_subscribers/4","type":"function"},{"doc":"Create multiple subscribers to a single topic.\n\n                            +------------+\n                  +---------+ subscriber |\n                  |         +------------+\n                  |\n                  |         +------------+\n                  +---------+ subscriber |\n    +-------+     |         +------------+\n    | topic +-----+\n    +-------+     |         +------------+\n                  +---------+ subscriber |\n                  |         +------------+\n                  |\n                  |         +------------+\n                  +---------+ subscriber |\n                            +------------+\n\n#","ref":"Rclex.Node.html#create_subscribers/4-type-single","title":"type: :single - Rclex.Node.create_subscribers/4","type":"function"},{"doc":"Create one-to-one subscribers for multiple topics.\n\n    +-------+               +------------+\n    | topic +---------------+ subscriber |\n    +-------+               +------------+\n                                          \n    +-------+               +------------+\n    | topic +---------------+ subscriber |\n    +-------+               +------------+\n                                          \n    +-------+               +------------+\n    | topic +---------------+ subscriber |\n    +-------+               +------------+\n                                          \n    +-------+               +------------+\n    | topic +---------------+ subscriber |\n    +-------+               +------------+","ref":"Rclex.Node.html#create_subscribers/4-type-multi","title":"type: :multi - Rclex.Node.create_subscribers/4","type":"function"},{"doc":"Finish subscribe/publish job.","ref":"Rclex.Node.html#finish_job/1","title":"Rclex.Node.finish_job/1","type":"function"},{"doc":"Finish subscribe/publish jobs.","ref":"Rclex.Node.html#finish_jobs/1","title":"Rclex.Node.finish_jobs/1","type":"function"},{"doc":"Get topic names and types, return example is below\n> [{'/topic', ['std_msgs/msg/String']}]","ref":"Rclex.Node.html#get_topic_names_and_types/3","title":"Rclex.Node.get_topic_names_and_types/3","type":"function"},{"doc":"Get Node name.","ref":"Rclex.Node.html#node_get_name/1","title":"Rclex.Node.node_get_name/1","type":"function"},{"doc":"Defines publish message functions.\n\nPublisher itself can be created on Node by calling below,\n* `Rclex.Node.create_publisher/3`\n* `Rclex.Node.create_publishers/4`","ref":"Rclex.Publisher.html","title":"Rclex.Publisher","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Rclex.Publisher.html#child_spec/1","title":"Rclex.Publisher.child_spec/1","type":"function"},{"doc":"","ref":"Rclex.Publisher.html#publish/2","title":"Rclex.Publisher.publish/2","type":"function"},{"doc":"","ref":"Rclex.Publisher.html#publish_once/3","title":"Rclex.Publisher.publish_once/3","type":"function"},{"doc":"","ref":"Rclex.Publisher.html#t:id_tuple/0","title":"Rclex.Publisher.id_tuple/0","type":"type"},{"doc":"Defines functions to manage ROS resources, Node and Timer.","ref":"Rclex.ResourceServer.html","title":"Rclex.ResourceServer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Rclex.ResourceServer.html#child_spec/1","title":"Rclex.ResourceServer.child_spec/1","type":"function"},{"doc":"Create specified name single Node without namespace.\nThis function calls `create_node_with_namespace/5` with namespace = ''.","ref":"Rclex.ResourceServer.html#create_node/4","title":"Rclex.ResourceServer.create_node/4","type":"function"},{"doc":"Create specified name single Node with specified namespace.","ref":"Rclex.ResourceServer.html#create_node_with_namespace/5","title":"Rclex.ResourceServer.create_node_with_namespace/5","type":"function"},{"doc":"* context: rcl context\n* node_name: node name\n* node_namespace: node namespace\n* queue_length: executor's queue length\n* change_order: function which change the order of job","ref":"Rclex.ResourceServer.html#create_node_with_namespace/5-arguments","title":"Arguments - Rclex.ResourceServer.create_node_with_namespace/5","type":"function"},{"doc":"Create specified name multiple Nodes without namespace.\nThis function calls `create_nodes_with_namespace/6` with node_namespace = ''.","ref":"Rclex.ResourceServer.html#create_nodes/5","title":"Rclex.ResourceServer.create_nodes/5","type":"function"},{"doc":"Create specified name multiple Nodes with specified node namespace.","ref":"Rclex.ResourceServer.html#create_nodes_with_namespace/6","title":"Rclex.ResourceServer.create_nodes_with_namespace/6","type":"function"},{"doc":"Create a specified name `Rclex.Timer` and a Supervisor which supervise the timer.\nThis function calls `create_timer_with_limit/7` with limit = 0(no limit).","ref":"Rclex.ResourceServer.html#create_timer/6","title":"Rclex.ResourceServer.create_timer/6","type":"function"},{"doc":"Create a specified name `Rclex.Timer` and a Supervisor which supervise the timer.\nArguments are used to configure `Rclex.Timer`.","ref":"Rclex.ResourceServer.html#create_timer_with_limit/7","title":"Rclex.ResourceServer.create_timer_with_limit/7","type":"function"},{"doc":"* callback: callback function\n* args: callback arguments\n* time: periodic time, milliseconds\n* timer_name: timer name\n* limit: limit of execution times, 0 means no limit\n* queue_length: executor's queue length\n* change_order: function which change the order of job","ref":"Rclex.ResourceServer.html#create_timer_with_limit/7-arguments","title":"Arguments - Rclex.ResourceServer.create_timer_with_limit/7","type":"function"},{"doc":"Finish `Rclex.Node` named with node_identifier by stopping its Supervisor.","ref":"Rclex.ResourceServer.html#finish_node/1","title":"Rclex.ResourceServer.finish_node/1","type":"function"},{"doc":"Call `finish_node/1` for each node_identifier_list element.","ref":"Rclex.ResourceServer.html#finish_nodes/1","title":"Rclex.ResourceServer.finish_nodes/1","type":"function"},{"doc":"ResourceServerプロセスの初期化\n    状態:\n        supervisor_ids :: map()\n        keyがnode_identifier、valueがnode情報。現在はnodeプロセスのsupervisorのidを格納している","ref":"Rclex.ResourceServer.html#init/1","title":"Rclex.ResourceServer.init/1","type":"function"},{"doc":"","ref":"Rclex.ResourceServer.html#start_link/1","title":"Rclex.ResourceServer.start_link/1","type":"function"},{"doc":"Stop `Rclex.Timer` named with timer_identifier by stopping its Supervisor.","ref":"Rclex.ResourceServer.html#stop_timer/1","title":"Rclex.ResourceServer.stop_timer/1","type":"function"},{"doc":"Defines rcl return code macros.\n\nTo use, `require Rclex.ReturnCode` first.","ref":"Rclex.ReturnCode.html","title":"Rclex.ReturnCode","type":"module"},{"doc":"","ref":"Rclex.ReturnCode.html#rcl_ret_bad_alloc/0","title":"Rclex.ReturnCode.rcl_ret_bad_alloc/0","type":"macro"},{"doc":"","ref":"Rclex.ReturnCode.html#rcl_ret_error/0","title":"Rclex.ReturnCode.rcl_ret_error/0","type":"macro"},{"doc":"","ref":"Rclex.ReturnCode.html#rcl_ret_ok/0","title":"Rclex.ReturnCode.rcl_ret_ok/0","type":"macro"},{"doc":"","ref":"Rclex.ReturnCode.html#rcl_ret_publisher_invalid/0","title":"Rclex.ReturnCode.rcl_ret_publisher_invalid/0","type":"macro"},{"doc":"","ref":"Rclex.ReturnCode.html#rcl_ret_subscription_invalid/0","title":"Rclex.ReturnCode.rcl_ret_subscription_invalid/0","type":"macro"},{"doc":"","ref":"Rclex.ReturnCode.html#rcl_ret_subscription_take_failed/0","title":"Rclex.ReturnCode.rcl_ret_subscription_take_failed/0","type":"macro"},{"doc":"","ref":"Rclex.ReturnCode.html#rcl_ret_timeout/0","title":"Rclex.ReturnCode.rcl_ret_timeout/0","type":"macro"},{"doc":"","ref":"Rclex.ReturnCode.html#rmw_ret_invalid_argument/0","title":"Rclex.ReturnCode.rmw_ret_invalid_argument/0","type":"macro"},{"doc":"Implements subscribing logic.","ref":"Rclex.SubLoop.html","title":"Rclex.SubLoop","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Rclex.SubLoop.html#child_spec/1","title":"Rclex.SubLoop.child_spec/1","type":"function"},{"doc":"","ref":"Rclex.SubLoop.html#do_nothing/0","title":"Rclex.SubLoop.do_nothing/0","type":"function"},{"doc":"購読処理関数\n    購読が正常に行われれば，引数に受け取っていたコールバック関数を実行","ref":"Rclex.SubLoop.html#each_subscribe/4","title":"Rclex.SubLoop.each_subscribe/4","type":"function"},{"doc":"","ref":"Rclex.SubLoop.html#start_link/1","title":"Rclex.SubLoop.start_link/1","type":"function"},{"doc":"","ref":"Rclex.SubLoop.html#start_sub/1","title":"Rclex.SubLoop.start_sub/1","type":"function"},{"doc":"Defines control, start/stop, `Rclex.SubLoop` functions.\n\nSubscriber itself can be created on Node by calling below,\n* `Rclex.Node.create_subscriber/3`\n* `Rclex.Node.create_subscribers/4`\n\nThere are 4 GenServers including this module itself under the Node.\nThey work together as shown below.\n    \n    +-------------+\n    | Rclex.Node  |\n    +-----+-------+\n          |\n          |\n          |\n          |                            +-------------------+                            +-------------------+\n          +------Supervisor------------+ Rclex.Subscriber  |------Supervisor------------+ Rclex.SubLoop     |\n          |                            +--------^----------+                            +--------+----------+\n          |                                     |                                                |\n          |                                     |                                                |\n          |                                     | GenServer.cast to Rclex.Subscriber             |\n          |                                     |                                                |\n          |                            +--------+----------+                                     |\n          |                    +-------+ Rclex.JobExecutor |          GenServer.cast to JobQueue |\n          |                    |       +--------^----------+                                     |\n          |                    |                |                                                |\n          +------Supervisor----+                | GenServer.cast to JobExecutor                  |\n                               |                |                                                |\n                               |       +--------+----------+                                     |\n                               +-------+ Rclex.JobQueue    <-------------------------------------+\n                                       +-------------------+                                      \n* This module stored `call_back` to be executed.\n* `Rclex.SubLoop` triggers the `call_back` execution according to pushing message to `Rclex.JobQueue`.","ref":"Rclex.Subscriber.html","title":"Rclex.Subscriber","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Rclex.Subscriber.html#child_spec/1","title":"Rclex.Subscriber.child_spec/1","type":"function"},{"doc":"subscriberを状態として持つ。start_subscribingをした際にcontextとcall_backを追加で状態として持つ。","ref":"Rclex.Subscriber.html#init/1","title":"Rclex.Subscriber.init/1","type":"function"},{"doc":"","ref":"Rclex.Subscriber.html#start_subscribing/3","title":"Rclex.Subscriber.start_subscribing/3","type":"function"},{"doc":"","ref":"Rclex.Subscriber.html#stop_subscribing/1","title":"Rclex.Subscriber.stop_subscribing/1","type":"function"},{"doc":"","ref":"Rclex.Subscriber.html#t:id_tuple/0","title":"Rclex.Subscriber.id_tuple/0","type":"type"},{"doc":"For periodically execution of jobs.\nThis module supervises two supervisor tree, one is for job control, one is for timer loop.\n\nThere are 4 GenServers including this module itself.\nThey work together as shown below.\n   \n    +-------------+\n    | Rclex.Timer <-----------------------------+\n    +-----+-------+                             |\n          |                                     | GenServer.cast to Rclex.Timer\n          |                                     |\n          |                            +--------+----------+\n          |                    +-------+ Rclex.JobExecutor |\n          |                    |       +--------^----------+\n          |                    |                |\n          +------Supervisor----+                | GenServer.cast to JobExecutor\n          |                    |                |\n          |                    |       +--------+----------+\n          |                    +-------+ Rclex.JobQueue    |\n          |                            +--------^----------+\n          |                                     |\n          |                                     | GenServer.cast to JobQueue\n          |                                     |\n          |                            +--------+----------+\n          +------Supervisor------------+ Rclex.TimerLoop   |\n                                       +-------------------+\n\n* This module stored `callback` and `args` to be executed.\n* `Rclex.TimerLoop` triggers the execution according to the `time` [msec].\n  * The number of executions is limited by `limit`.","ref":"Rclex.Timer.html","title":"Rclex.Timer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Rclex.Timer.html#child_spec/1","title":"Rclex.Timer.child_spec/1","type":"function"},{"doc":"Initialize GenServer","ref":"Rclex.Timer.html#init/1","title":"Rclex.Timer.init/1","type":"function"},{"doc":"* callback: callback function\n* args: callback arguments\n* time: execution interval time, milli seconds\n* limit: execution times limit\n* queue_length: queue length for `Rclex.JobQueue`\n* change_order: change order function for `Rclex.JobExecutor`","ref":"Rclex.Timer.html#init/1-arguments-in-tuple","title":"Arguments in tuple - Rclex.Timer.init/1","type":"function"},{"doc":"Pushes timer jobs to `Rclex.JobQueue`.","ref":"Rclex.TimerLoop.html","title":"Rclex.TimerLoop","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Rclex.TimerLoop.html#child_spec/1","title":"Rclex.TimerLoop.child_spec/1","type":"function"},{"doc":"","ref":"Rclex.TimerLoop.html#start_link/1","title":"Rclex.TimerLoop.start_link/1","type":"function"},{"doc":"[![Hex version](https://img.shields.io/hexpm/v/rclex.svg \"Hex version\")](https://hex.pm/packages/rclex)\n[![API docs](https://img.shields.io/hexpm/v/rclex.svg?label=hexdocs \"API docs\")](https://hexdocs.pm/rclex/readme.html)\n[![License](https://img.shields.io/hexpm/l/rclex.svg)](https://github.com/rclex/rclex/blob/main/LICENSE)\n[![ci-latest_push](https://github.com/rclex/rclex/actions/workflows/ci_latest.yml/badge.svg)](https://github.com/rclex/rclex/actions/workflows/ci_latest.yml)\n[![ci-allver_PR](https://github.com/rclex/rclex/actions/workflows/ci_allver.yml/badge.svg)](https://github.com/rclex/rclex/actions/workflows/ci_allver.yml)\n\n[日本語のREADME](README_ja.md)\n\n# Rclex\n\nRclex is a ROS 2 client library for Elixir.\n\nThis library lets you perform basic ROS 2 behaviors by calling out from Elixir code into the RCL (ROS Client Library) API, which\nuses the ROS 2 common hierarchy.\n\nAdditionally, publisher-subscriber (PubSub) communication between nodes and associated callback functions are executed by *tasks*,\nwhich are part of a lightweight process model. This enables generation of and communication between a large number of fault-tolerant\nnodes while suppressing memory load.","ref":"readme.html","title":"README","type":"extras"},{"doc":"ROS (Robot Operating System) is a next-generation Robot development platform. In both ROS and ROS 2, each functional\nunit is exposed as a node, and by combining these nodes you can create different robot applications. Additionally,\ncommunication between nodes uses a PubSub model where publisher and subscriber exchange information by specifying a\ncommon topic name.\n\nThe biggest difference between ROS and ROS 2 is that the DDS (Data Distribution Service) protocol was adopted for\ncommunication, and the library was divided in a hierarchical structure, allowing for the creation of ROS 2 client\nlibraries in various languages. This has allowed for the creation of a robot application library in Elixir.\n\nFor details on ROS 2, see the official [ROS 2 documentation](https://index.ros.org/doc/ros2/).","ref":"readme.html#what-is-ros-2","title":"What is ROS 2 - README","type":"extras"},{"doc":"#","ref":"readme.html#recommended-environment","title":"Recommended environment - README","type":"extras"},{"doc":"Currently, we use the following environment as the main development target:\n\n- Ubuntu 22.04.3 LTS (Jammy Jellyfish)\n- ROS 2 [Humble Hawksbill](https://docs.ros.org/en/humble/Releases/Release-Humble-Hawksbill.html)\n- Elixir 1.15.5-otp-26\n- Erlang/OTP 26.0.2\n\nWe highly recommend using Humble for ROS 2 distribution.\nAlthough we also use Foxy and Galactic as CI targets, they have already reached EOL.\n\nFor other environments used to check the operation of this library,\nplease refer to [here](https://github.com/rclex/rclex_docker#available-versions-docker-tags).\n\n#","ref":"readme.html#the-environment-where-host-development-and-target-operation-are-the-same","title":"The environment where host (development) and target (operation) are the same - README","type":"extras"},{"doc":"The pre-built Docker images are available at [Docker Hub](https://hub.docker.com/r/rclex/rclex_docker).\nYou can also try the power of Rclex with it easily. Please check [\"Docker Environment\"](#Docker-environment) section for details.\n\n#","ref":"readme.html#docker-environment","title":"Docker environment - README","type":"extras"},{"doc":"`rclex` can be operated onto Nerves. In this case, you do not need to prepare the ROS 2 environment on the host computer to build Nerves project (so awesome!).\n\nPlease refer to [Use on Nerves](USE_ON_NERVES.md) section and [b5g-ex/rclex_on_nerves](https://github.com/b5g-ex/rclex_on_nerves) example repository for more details!","ref":"readme.html#nerves-device-target","title":"Nerves device (target) - README","type":"extras"},{"doc":"Currently, the Rclex API allows for the following:\n\n1. The ability to create a large number of publishers sending to the same topic.\n2. The ability to create large numbers of each combination of publishers, topics, and subscribers.\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm).  \nYou can find the docs at [https://hexdocs.pm/rclex](https://hexdocs.pm/rclex).\n\nPlease refer [rclex/rclex_examples](https://github.com/rclex/rclex_examples) for the examples of usage along with the sample code.","ref":"readme.html#features","title":"Features - README","type":"extras"},{"doc":"This section explains the quickstart for `rclex` onto the environment where ROS 2 and Elixir have been installed.\n\n#","ref":"readme.html#how-to-use","title":"How to use - README","type":"extras"},{"doc":"First of all, create the Mix project as a normal Elixir project.\n\n```\nmix new rclex_usage\ncd rclex_usage\n```\n\n#","ref":"readme.html#create-the-project","title":"Create the project - README","type":"extras"},{"doc":"`rclex` is [available in Hex](https://hex.pm/docs/publish).\n\nYou can install this package into your project\nby adding `rclex` to your list of dependencies in `mix.exs`:\n\n```elixir\n  defp deps do\n    [\n      ...\n      {:rclex, \"~> 0.9.0\"},\n      ...\n    ]\n  end\n```\n\nAfter that, execute `mix deps.get` into the project repository.\n\n```\nmix deps.get\n```\n\n#","ref":"readme.html#install-rclex","title":"Install rclex - README","type":"extras"},{"doc":"```\nsource /opt/ros/humble/setup.bash\n```","ref":"readme.html#setup-the-ros-2-environment","title":"Setup the ROS 2 environment - README","type":"extras"},{"doc":"Rclex provides pub/sub based topic communication using the message type defined in ROS 2. Please refer [here](https://docs.ros.org/en/humble/Concepts/About-ROS-Interfaces.html) for more details about message types in ROS 2.\n\nThe message types you want to use in your project can be specified in `ros2_message_types` in `config/config.exs`. \nMultiple message types can be specified separated by comma `,`.\n\nThe following `config/config.exs` example wants to use `String` type.\n\n```elixir\nimport Config\n\nconfig :rclex, ros2_message_types: [\"std_msgs/msg/String\"]\n```\n\nThen, execute the following Mix task to generate required definitions and files for message types.\n\n```\nmix rclex.gen.msgs\n```\n\nIf you want to change the message types in config, do `mix rclex.gen.msgs` again.\n\n#","ref":"readme.html#configure-ros-2-message-types-you-want-to-use","title":"Configure ROS 2 message types you want to use - README","type":"extras"},{"doc":"Now, you can acquire the environment for [Rclex API](https://hexdocs.pm/rclex/api-reference.html)! Of course, you can execute APIs on IEx directly.\n\nHere is the simplest implementation example `lib/rclex_usage.ex` that will publish the string to `/chatter` topic.\n\n```elixir\ndefmodule RclexUsage do\n  def publish_message do\n    context = Rclex.rclexinit()\n    {:ok, node} = Rclex.ResourceServer.create_node(context, 'talker')\n    {:ok, publisher} = Rclex.Node.create_publisher(node, 'StdMsgs.Msg.String', 'chatter')\n\n    msg = Rclex.Msg.initialize('StdMsgs.Msg.String')\n    data = \"Hello World from Rclex!\"\n    msg_struct = %Rclex.StdMsgs.Msg.String{data: String.to_charlist(data)}\n    Rclex.Msg.set(msg, msg_struct, 'StdMsgs.Msg.String')\n\n    # This sleep is essential for now, see Issue #212\n    Process.sleep(100)\n\n    IO.puts(\"Rclex: Publishing: #{data}\")\n    Rclex.Publisher.publish([publisher], [msg])\n\n    Rclex.Node.finish_job(publisher)\n    Rclex.ResourceServer.finish_node(node)\n    Rclex.shutdown(context)\n  end\nend\n```\n\nPlease also check the examples for Rclex.\n- [rclex/rclex_examples](https://github.com/rclex/rclex_examples)\n\n#","ref":"readme.html#write-rclex-code","title":"Write Rclex code - README","type":"extras"},{"doc":"```\nmix compile\niex -S mix\n```\n\nOperate the following command on IEx.\n\n```\niex()> RclexUsage.publish_message\n\n00:04:40.701 [debug] JobExecutor start\n \n00:04:40.705 [debug] talker0/chatter/pub\nRclex: Publishing: Hello World from Rclex!\n\n00:04:40.706 [debug] publish ok\n \n00:04:40.706 [debug] publisher finished: talker0/chatter/pub\n \n00:04:40.710 [debug] finish node: talker0\n{:ok, #Reference }\n```\n\nYou can confirm the above operation by subscribing with `ros2 topic echo` from the other terminal.\n\n```\n$ source /opt/ros/humble/setup.bash\n$ ros2 topic echo /chatter std_msgs/msg/String\ndata: Hello World from Rclex!\n---\n```","ref":"readme.html#build-and-execute","title":"Build and Execute - README","type":"extras"},{"doc":"This section describes the information mainly for developers.\n\n#","ref":"readme.html#enhance-devepoment-experience","title":"Enhance devepoment experience - README","type":"extras"},{"doc":"This repository provides a `docker compose` environment for library development with Docker.\n\nAs mentioned above, pre-built Docker images are available at [Docker Hub](https://hub.docker.com/r/rclex/rclex_docker), which can be used to easily try out Rclex.\nYou can set the environment variable `$RCLEX_DOCKER_TAG` to the version of the target environment. Please refer to [here](https://github.com/rclex/rclex_docker#available-versions-docker-tags) for the available environments.\n\n```\n# optional: set to the target environment (default `latest`)\nexport RCLEX_DOCKER_TAG=latest\n# create and start the container\ndocker compose up -d\n# execute the container (with the workdir where this repository is mounted)\ndocker compose exec -w /root/rclex rclex_docker /bin/bash\n# stop the container\ndocker compose down\n```\n\n#","ref":"readme.html#docker-environment","title":"Docker environment - README","type":"extras"},{"doc":"`mix test.watch` is introduced to automatically run unit test `mix test` and code formatting `mix format` every time the source code was edited.\n\n```\n$ mix test.watch\n# or, run on docker by following\n$ docker compose run --rm -w /root/rclex rclex_docker mix test.watch\n```\n\n#","ref":"readme.html#automatic-execution-of-mix-test-etc","title":"Automatic execution of mix test, etc. - README","type":"extras"},{"doc":"To check the operation of this library, we prepare [rclex/rclex_connection_tests](https://github.com/rclex/rclex_connection_tests) to test the communication with the nodes implemented with Rclcpp.\n\n```\ncd /path/to/yours\ngit clone https://github.com/rclex/rclex\ngit clone https://github.com/rclex/rclex_connection_tests\ncd /path/to/yours/rclex_connection_tests\n./run-all.sh\n```\n\nIn [GitHub Actions](https://github.com/rclex/rclex/actions), we perform CI on multiple environments at Pull Requests. HOwever, we cannot guarantee operation in all of these environments.","ref":"readme.html#confirmation-of-operation","title":"Confirmation of operation - README","type":"extras"},{"doc":"- [@takasehideki](https://github.com/takasehideki)\n- [@HiroiImanishi](https://github.com/HiroiImanishi)\n- [@kebus426](https://github.com/kebus426)\n- [@shiroro466](https://github.com/shiroro466)\n- [@s-hosoai](https://github.com/s-hosoai)","ref":"readme.html#maintainers-and-developers-including-past","title":"Maintainers and developers (including past) - README","type":"extras"},{"doc":"[![Hex version](https://img.shields.io/hexpm/v/rclex.svg \"Hex version\")](https://hex.pm/packages/rclex)\n[![API docs](https://img.shields.io/hexpm/v/rclex.svg?label=hexdocs \"API docs\")](https://hexdocs.pm/rclex/readme.html)\n[![License](https://img.shields.io/hexpm/l/rclex.svg)](https://github.com/rclex/rclex/blob/main/LICENSE)\n[![ci-all_version](https://github.com/rclex/rclex/actions/workflows/ci.yml/badge.svg)](https://github.com/rclex/rclex/actions/workflows/ci.yml)\n\n注：READMEは[英語版](README.md)が常に最新かつ確実です．\n\n# Rclex [Ja]\nElixirによるROS 2クライアントライブラリです．\nROS 2共通階層であるRCL（ROS Client Library）APIをElixirコードから呼び出すことで基本的なROS 2の振る舞いをさせています．\nまたノード間の出版購読通信およびそれに付随するコールバック関数をプロセスモデルの一つであるタスクに実行させることで軽量にしています．\nこれにより，メモリへの負荷を抑えつつ，また耐障害性を高めてノードを大量に生成，通信させることが可能になっています．","ref":"readme_ja.html","title":"README_ja","type":"extras"},{"doc":"ROS（Robot Operating System）というロボット開発を支援するプラットフォームの次世代版です．\nROS，ROS 2ともに，機能単位をノードと表現し，ノードを複数組み合わせて所望のさまざまなロボットアプリケーションが作成できます．\nまたノード間通信には出版購読通信が主に用いられ，パブリッシャとサブスクライバがトピックという名前でデータを識別してやりとりしています．\n\nROSからの大きな違いとして，通信にDDS（Data Distribution Service）プロトコルが採用されたこと，そしてライブラリが階層構造に分けられ，様々な言語でROS 2クライアントライブラリを開発できるようになったことです．これにより，Elixirでもロボットアプリケーションを開発できるようになりました．\n\n詳しくはROS 2の[公式ドキュメント](https://index.ros.org/doc/ros2/)を参照ください．","ref":"readme_ja.html#ros-2%E3%81%A8%E3%81%AF","title":"ROS 2とは - README_ja","type":"extras"},{"doc":"#","ref":"readme_ja.html#%E5%AF%BE%E8%B1%A1%E3%81%A8%E3%81%99%E3%82%8B%E7%92%B0%E5%A2%83","title":"対象とする環境 - README_ja","type":"extras"},{"doc":"現在，下記の環境を主な対象として開発を進めています．\n\n- Ubuntu 22.04.3 LTS (Jammy Jellyfish)\n- ROS 2 [Humble Hawksbill](https://docs.ros.org/en/humble/Releases/Release-Humble-Hawksbill.html)\n- Elixir 1.15.5-otp-26\n- Erlang/OTP 26.0.2\n\nROS 2にはHumbleの利用を強く推奨します．\nFoxyとGalacticもCI対象としていますが，これらはすでにEOLとなっています．\n\n動作検証の対象としている環境は[こちら](https://github.com/rclex/rclex_docker#available-versions-docker-tags)を参照してください．\n\n#","ref":"readme_ja.html#%E3%83%9B%E3%82%B9%E3%83%88-%E9%96%8B%E7%99%BA%E7%92%B0%E5%A2%83-%E3%81%A8%E3%82%BF%E3%83%BC%E3%82%B2%E3%83%83%E3%83%88-%E5%AE%9F%E8%A1%8C%E7%92%B0%E5%A2%83-%E3%81%8C%E5%90%8C%E4%B8%80%E3%81%AE%E5%A0%B4%E5%90%88","title":"ホスト（開発環境）とターゲット（実行環境）が同一の場合 - README_ja","type":"extras"},{"doc":"[Docker Hub](https://hub.docker.com/r/rclex/rclex_docker)にてビルド済みのDockerイメージを公開しており，これを用いてRclexを簡単に試行することもできます．\n詳細は[「Docker環境の利用」](#Docker環境の利用)のセクションを参照してください．\n\n#","ref":"readme_ja.html#docker%E7%92%B0%E5%A2%83","title":"Docker環境 - README_ja","type":"extras"},{"doc":"`rclex` はNerves上での実行も可能です．この場合，ホスト環境にはROS 2環境を導入する必要はありません．\n\n詳細は[Use on Nerves](USE_ON_NERVES.md)の章および[b5g-ex/rclex_on_nerves](https://github.com/b5g-ex/rclex_on_nerves)のリポジトリによる例を参照してください．","ref":"readme_ja.html#nerves%E3%83%87%E3%83%90%E3%82%A4%E3%82%B9-%E3%82%BF%E3%83%BC%E3%82%B2%E3%83%83%E3%83%88","title":"Nervesデバイス（ターゲット） - README_ja","type":"extras"},{"doc":"現時点では以下のことができるようにRclex APIを提供しています．\n1. 同一トピックに対して，複数のパブリッシャおよびサブスクライバを大量に作成できる．\n2. パブリッシャ，トピック，サブスクライバが1つずつのペアを大量に作成できる．\n\nドキュメントは[ExDoc](https://github.com/elixir-lang/ex_doc)で生成されて[HexDocs](https://hexdocs.pm)に公開されています．  \n[https://hexdocs.pm/rclex](https://hexdocs.pm/rclex)をご参照ください．\n\n使用例は[rclex/rclex_examples](https://github.com/rclex/rclex_examples)を参照してください．サンプルコードとともに使い方を記しています．","ref":"readme_ja.html#%E6%A9%9F%E8%83%BD","title":"機能 - README_ja","type":"extras"},{"doc":"ここでは，ROS 2およびElixirの動作環境がインストール済みである計算機での`rclex`の使用方法を示します．\n\n#","ref":"readme_ja.html#%E4%BD%BF%E7%94%A8%E6%96%B9%E6%B3%95","title":"使用方法 - README_ja","type":"extras"},{"doc":"通常のElixirプロジェクトと同様に作成します．\n\n```\nmix new rclex_usage\ncd rclex_usage\n```\n\n#","ref":"readme_ja.html#%E3%83%97%E3%83%AD%E3%82%B8%E3%82%A7%E3%82%AF%E3%83%88%E3%81%AE%E4%BD%9C%E6%88%90","title":"プロジェクトの作成 - README_ja","type":"extras"},{"doc":"`rclex` は[Hexパッケージとして公開](https://hex.pm/docs/publish)しています．\n\n`mix.exs` の依存関係に `rclex` を追加することで，ご自身のプロジェクトにて使用することができます．\n\n```elixir\n  defp deps do\n    [\n      ...\n      {:rclex, \"~> 0.9.0\"},\n      ...\n    ]\n  end\n```\n\n上記を追加後，プロジェクトのディレクトリ内で `mix deps.get` を実行してください．\n\n```\nmix deps.get\n```\n\n#","ref":"readme_ja.html#rclex%E3%81%AE%E3%82%A4%E3%83%B3%E3%82%B9%E3%83%88%E3%83%BC%E3%83%AB","title":"rclexのインストール - README_ja","type":"extras"},{"doc":"```\nsource /opt/ros/humble/setup.bash\n```\n\n#","ref":"readme_ja.html#ros-2%E3%81%AE%E7%92%B0%E5%A2%83%E8%A8%AD%E5%AE%9A","title":"ROS 2の環境設定 - README_ja","type":"extras"},{"doc":"Rclexでは，ROS 2において定義されるメッセージの型を利用して出版購読型のトピック通信を行うことができます．ROS 2におけるメッセージの型については[こちら](https://docs.ros.org/en/humble/Concepts/About-ROS-Interfaces.html)を参照してください．\n\nプロジェクトで使用したいメッセージの型は，`config/config.exs` における `ros2_message_types` で指定します．コンマ区切り `,` で複数の型を指定することもできます．\n\nここでは `String` 型を使用したい `config/config.exs` の例を示します．\n\n```elixir\nimport Config\n\nconfig :rclex, ros2_message_types: [\"std_msgs/msg/String\"]\n```\n\nその後，次のMixタスクを実行し，メッセージの型を使用するために必要な定義とファイル群を自動生成します．\n\n```\nmix rclex.gen.msgs\n```\n\n#","ref":"readme_ja.html#%E3%83%A1%E3%83%83%E3%82%BB%E3%83%BC%E3%82%B8%E3%81%AE%E5%9E%8B%E3%81%AE%E8%A8%AD%E5%AE%9A","title":"メッセージの型の設定 - README_ja","type":"extras"},{"doc":"これで Rclex を使用する準備が整いました！  \nもちろんIEx上で[RclexのAPI](https://hexdocs.pm/rclex/api-reference.html)を直接実行することもできます．\n\nここでは，最も単純なコードを対象として，プロジェクトの実装例を示します．\n次のコード `lib/rclex_usage.ex` は，`String`型のトピック `/chatter` に対して文字列を出版する処理を示しています．\n\n```elixir\ndefmodule RclexUsage do\n  def publish_message do\n    context = Rclex.rclexinit()\n    {:ok, node} = Rclex.ResourceServer.create_node(context, 'talker')\n    {:ok, publisher} = Rclex.Node.create_publisher(node, 'StdMsgs.Msg.String', 'chatter')\n\n    msg = Rclex.Msg.initialize('StdMsgs.Msg.String')\n    data = \"Hello World from Rclex!\"\n    msg_struct = %Rclex.StdMsgs.Msg.String{data: String.to_charlist(data)}\n    Rclex.Msg.set(msg, msg_struct, 'StdMsgs.Msg.String')\n\n    # This sleep is essential for now, see Issue #212\n    Process.sleep(100)\n\n    IO.puts(\"Rclex: Publishing: #{data}\")\n    Rclex.Publisher.publish([publisher], [msg])\n\n    Rclex.Node.finish_job(publisher)\n    Rclex.ResourceServer.finish_node(node)\n    Rclex.shutdown(context)\n  end\nend\n```\n\nこの他の実装例は，下記も参照してください．\n- [rclex/rclex_examples](https://github.com/rclex/rclex_examples)\n\n#","ref":"readme_ja.html#%E3%82%B3%E3%83%BC%E3%83%89%E3%81%AE%E5%AE%9F%E8%A3%85","title":"コードの実装 - README_ja","type":"extras"},{"doc":"```\nmix compile\niex -S mix\n```\n\nIEx上で次のように実行してください．\n\n```\niex()> RclexUsage.publish_message\n\n00:04:40.701 [debug] JobExecutor start\n \n00:04:40.705 [debug] talker0/chatter/pub\nRclex: Publishing: Hello World from Rclex!\n\n00:04:40.706 [debug] publish ok\n \n00:04:40.706 [debug] publisher finished: talker0/chatter/pub\n \n00:04:40.710 [debug] finish node: talker0\n{:ok, #Reference }\n```\n\nこのメッセージの出版結果は，ROS 2コマンド`ros2 topic echo`によって購読して確認できます．\n\n```\n$ source /opt/ros/humble/setup.bash\n$ ros2 topic echo /chatter std_msgs/msg/String\ndata: Hello World from Rclex!\n---\n```","ref":"readme_ja.html#%E3%83%93%E3%83%AB%E3%83%89%E3%81%A8%E5%AE%9F%E8%A1%8C","title":"ビルドと実行 - README_ja","type":"extras"},{"doc":"本セクションでは主に開発者向けの情報を示します．\n\n#","ref":"readme_ja.html#%E9%96%8B%E7%99%BA%E3%81%AE%E5%86%86%E6%BB%91%E5%8C%96","title":"開発の円滑化 - README_ja","type":"extras"},{"doc":"本リポジトリでは，Dockerでライブラリ開発を進めるための`docker compose`による環境を提供しています．\n\n前述の通り[Docker Hub](https://hub.docker.com/r/rclex/rclex_docker)にてビルド済みのDockerイメージを公開しており，これを用いることでRclexを簡単に試行できます．\n環境変数 `$RCLEX_DOCKER_TAG` にて対象とする実行環境のバージョンを設定できます．設定可能な実行環境は[こちら](https://github.com/rclex/rclex_docker#available-versions-docker-tags)を参照してください．\n\n```\n# optional: 実行環境の設定（デフォルトは`latest`）\nexport RCLEX_DOCKER_TAG=latest\n# コンテナを作成して起動\ndocker compose up -d\n# コンテナの実行（本リポジトリのマウントポイントを作業ディレクトリに）\ndocker compose exec -w /root/rclex rclex_docker /bin/bash\n# コンテナの終了\ndocker compose down\n```\n\n#","ref":"readme_ja.html#docker%E7%92%B0%E5%A2%83%E3%81%AE%E5%88%A9%E7%94%A8","title":"Docker環境の利用 - README_ja","type":"extras"},{"doc":"`mix test.watch` を導入しており，ソースコードの編集時毎に，単体テスト `mix test` やコード整形 `mix format` を自動実行できます．\n\n```\n$ mix test.watch\n# または docker で動作させるには\n$ docker compose run --rm -w /root/rclex rclex_docker mix test.watch\n```\n\n#","ref":"readme_ja.html#mix-test%E7%AD%89%E3%81%AE%E8%87%AA%E5%8B%95%E5%AE%9F%E8%A1%8C","title":"mix test等の自動実行 - README_ja","type":"extras"},{"doc":"動作確認として，[rclex/rclex_connection_tests](https://github.com/rclex/rclex_connection_tests)を用いてRclcppで実装されたノードとの通信に関するテストを実施しています．\n\n```\ncd /path/to/yours\ngit clone https://github.com/rclex/rclex\ngit clone https://github.com/rclex/rclex_connection_tests\ncd /path/to/yours/rclex_connection_tests\n./run-all.sh\n```\n\n[GitHub Actions](https://github.com/rclex/rclex/actions)では，複数の環境でのCIを実行しています．ただし，これら全ての環境での動作保証には対応できません．","ref":"readme_ja.html#%E5%8B%95%E4%BD%9C%E7%A2%BA%E8%AA%8D","title":"動作確認 - README_ja","type":"extras"},{"doc":"- [@takasehideki](https://github.com/takasehideki)\n- [@HiroiImanishi](https://github.com/HiroiImanishi)\n- [@kebus426](https://github.com/kebus426)\n- [@shiroro466](https://github.com/shiroro466)\n- [@s-hosoai](https://github.com/s-hosoai)","ref":"readme_ja.html#%E4%B8%BB%E3%81%AA%E7%AE%A1%E7%90%86%E8%80%85%E3%81%A8%E9%96%8B%E7%99%BA%E8%80%85-%E9%81%8E%E5%8E%BB%E5%88%86%E3%82%82%E5%90%AB%E3%82%80","title":"主な管理者と開発者（過去分も含む） - README_ja","type":"extras"},{"doc":"# Use on Nerves\n\n`rclex` can be operated onto Nerves. In this case, you do not need to prepare the ROS 2 environment on the host computer to build Nerves project (so awesome!).\n\nThis doc shows the steps on how to use Rclex on Nerves from scratch.\n\nWe have also published the Nerves project that has been prepared and includes example code at [b5g-ex/rclex_on_nerves](https://github.com/b5g-ex/rclex_on_nerves). Please also refer to this repository.","ref":"use_on_nerves.html","title":"Use on Nerves","type":"extras"},{"doc":"Currently, we have confirmed the following boards as the Nerves device that can operate Rclex (good luck to get one!).\n\n| board | tag | arch | support for nerves_system |\n| :--- | :--- | :---| :---|\n| [Raspberry Pi 4](https://github.com/nerves-project/nerves_system_rpi4) | rpi4 | arm64v8 | Officially supported, recommended |\n| [BeagleBone Green](https://github.com/nerves-project/nerves_system_bbb) | bbb | arm32v7 | Officially supported |\n| [Kria KR260](https://github.com/b5g-ex/nerves_system_kr260) | kr260 | arm64v8 | Third-party supported |\n| [ODYSSEY - STM32MP157C](https://github.com/b5g-ex/nerves_system_stm32mp157c_odyssey) | stm32mp157c_odyssey | arm32v7 | Third-party supported |\n| [F3RP70 (e-RT3 Plus)](https://github.com/pojiro/nerves_system_f3rp70) | f3rp70 | arm32v7 | Third-party supported |\n\nThe below is the supported ROS 2 distribution and architecture that can operate rclex_on_nerves.\nThe \"support\" colomn refers to its status of official support as the ROS 2 distribution.\n\n| `ROS_DISTRO` | arm64v8 | arm32v7 | support |\n| :--- | :--- | :---| :---|\n| humble | ○ | ○ | LTS until May 2027 |\n| galactic | ○ | - | EOL at Dec 2022 |\n| foxy | ○ | ○ | EOL at Jun 2023 |","ref":"use_on_nerves.html#supported-targets","title":"Supported Targets - Use on Nerves","type":"extras"},{"doc":"During the procedure for Rclex on Nerves, the docker command is used to copy the necessary directory in `mix rclex.prep.ros2`.\nPlease install [Docker Desktop](https://docs.docker.com/desktop/) or [Docker Engine](https://docs.docker.com/engine/), and start it first.  \nAnd also, Rclex on Nerves will deploy an docker container for arm64 arch. If you want to operate this project by Docker Engine on other platforms (x86_64), you need to install qemu as the follows: `sudo apt-get install qemu binfmt-support qemu-user-static`\n\nIt should be noted that do not perform the following steps inside a docker container.  \nOnce again, they can be operated even if ROS 2 is not installed on the host machine!","ref":"use_on_nerves.html#preliminaries","title":"Preliminaries - Use on Nerves","type":"extras"},{"doc":"> ##","ref":"use_on_nerves.html#procedure","title":"Procedure - Use on Nerves","type":"extras"},{"doc":">\n> The following steps assume that `rpi4` and `arm64v8` will be used as the target Nerves device.\n> You may change the values of `MIX_TARGET` and `--arch` to match the \"tag\" and \"arch\" columns on the supported target list according to the board you want to use.\n\n#","ref":"use_on_nerves.html#target-device-neutral","title":"Target device {: .neutral } - Use on Nerves","type":"extras"},{"doc":"```\nmix nerves.new rclex_usage_on_nerves --target rpi4\ncd rclex_usage_on_nerves\nexport MIX_TARGET=rpi4\nmix deps.get\n```\n\n> ##","ref":"use_on_nerves.html#create-nerves-project","title":"Create Nerves Project - Use on Nerves","type":"extras"},{"doc":">\n> If `mix deps.get` failed, you may need to create SSH key and configure config/target.exs.\n\n#","ref":"use_on_nerves.html#note-warning","title":"Note {: .warning } - Use on Nerves","type":"extras"},{"doc":"`rclex` is [available in Hex](https://hex.pm/docs/publish).\n\nYou can install this package into your project\nby adding `rclex` to your list of dependencies in `mix.exs`:\n\n```elixir\n  defp deps do\n    [\n      ...\n      {:rclex, \"~> 0.9.0\"},\n      ...\n    ]\n  end\n```\n\nAfter that, execute `mix deps.get` into the project repository.\n\n```\nmix deps.get\n```\n\n#","ref":"use_on_nerves.html#install-rclex","title":"Install rclex - Use on Nerves","type":"extras"},{"doc":"> ##","ref":"use_on_nerves.html#prepare-ros-2-resources","title":"Prepare ROS 2 resources - Use on Nerves","type":"extras"},{"doc":">\n> In the following steps, Humble Hawksbill (`humble`) is assumed to be used as `ROS_DISTRO` (strongly recommend to use).\n> If you want to use `foxy` or `galactic`, you need to replace it appropriately in the subsequent steps. Note that these have already reached EOL.\n\nThe following command extracts the ROS 2 Docker image and copies resources required for Rclex to the Nerves file system.\nYou may change the value of `--arch` according to the architecture of your target board (see the \"arch\" column on the supported target list)\n\n```\nexport ROS_DISTRO=humble\nmix rclex.prep.ros2 --arch arm64v8\n```\n\n> ##","ref":"use_on_nerves.html#note-info","title":"Note {: .info } - Use on Nerves","type":"extras"},{"doc":">\n> The following warning messages will occur at several times when the host and target architectures are different. These can be ignored.\n> > WARNING: The requested image's platform (linux/arm/v7) does not match the detected host platform (linux/amd64) and no specific platform was requested\n\n#","ref":"use_on_nerves.html#note-warning","title":"Note {: .warning } - Use on Nerves","type":"extras"},{"doc":"Rclex provides pub/sub based topic communication using the message type defined in ROS 2. Please refer [here](https://docs.ros.org/en/humble/Concepts/About-ROS-Interfaces.html) for more details about message types in ROS 2.\n\nThe message types you want to use in your project can be specified in `ros2_message_types` in `config/config.exs`. \nMultiple message types can be specified separated by comma `,`.\n\nThe following `config/config.exs` example wants to use `String` type.\n\n```elixir\nconfig :rclex, ros2_message_types: [\"std_msgs/msg/String\"]\n```\n\nThen, execute the following Mix task to generate required definitions and files for message types.\n\n```\nmix rclex.gen.msgs\n```\n\nIf you want to change the message types in config, do `mix rclex.gen.msgs` again.\n\n#","ref":"use_on_nerves.html#configure-ros-2-message-types-you-want-to-use","title":"Configure ROS 2 message types you want to use - Use on Nerves","type":"extras"},{"doc":"Copy erlinit.config from `nerves_system_***`.\n\n```\ncp deps/nerves_system_rpi4/rootfs_overlay/etc/erlinit.config rootfs_overlay/etc\n```\n\nAdd LD_LIBRARY_PATH line like following.  \n`ROS_DISTRO` should be written directly such as `humble`, as the below.\n\n```\n# Enable UTF-8 filename handling in Erlang and custom inet configuration\n-e LANG=en_US.UTF-8;LANGUAGE=en;ERL_INETRC=/etc/erl_inetrc\n\n# Enable crash dumps (set ERL_CRASH_DUMP_SECONDS=0 to disable)\n-e ERL_CRASH_DUMP=/root/erl_crash.dump;ERL_CRASH_DUMP_SECONDS=5\n\n# add for ROS 2 (rclex_on_nerves)\n-e LD_LIBRARY_PATH=/opt/ros/humble/lib\n```\n\n> ##","ref":"use_on_nerves.html#copy-erlinit-config-to-rootfs_overlay-etc-and-add-ld_library_path","title":"Copy erlinit.config to rootfs_overlay/etc and add LD_LIBRARY_PATH - Use on Nerves","type":"extras"},{"doc":">\n> ROS 2 needs the path. If you want to know the details, please read following\n>\n> - https://github.com/ros-tooling/cross_compile/issues/363\n> - https://github.com/ros2/rcpputils/pull/122\n\n> ##","ref":"use_on_nerves.html#why-add-ld_library_path-explicitly-info","title":"Why add LD_LIBRARY_PATH explicitly {: .info } - Use on Nerves","type":"extras"},{"doc":">\n> If you want to use `galactic`, adding line should be as the below.\n> \n> ```\n>","ref":"use_on_nerves.html#note-warning","title":"Note {: .warning } - Use on Nerves","type":"extras"},{"doc":"> # -e LD_LIBRARY_PATH=/opt/ros/galactic/lib/aarch64-linux-gnu:/opt/ros/galactic/lib\n> ```\n\n#","ref":"use_on_nerves.html#only-galactic-needs-opt-ros-galactic-lib-aarch64-linux-gnu-also-for-libddsc","title":"only galactic needs /opt/ros/galactic/lib/aarch64-linux-gnu also, for libddsc - Use on Nerves","type":"extras"},{"doc":"Now, you can acquire the environment for [Rclex API](https://hexdocs.pm/rclex/api-reference.html)! Of course, you can execute APIs on IEx directly.\n\nHere is the simplest implementation example `lib/rclex_usage_on_nerves.ex` that will publish the string to `/chatter` topic.\n\n```elixir\ndefmodule RclexUsageOnNerves do\n  def publish_message do\n    context = Rclex.rclexinit()\n    {:ok, node} = Rclex.ResourceServer.create_node(context, 'talker')\n    {:ok, publisher} = Rclex.Node.create_publisher(node, 'StdMsgs.Msg.String', 'chatter')\n\n    msg = Rclex.Msg.initialize('StdMsgs.Msg.String')\n    data = \"Hello World from Rclex!\"\n    msg_struct = %Rclex.StdMsgs.Msg.String{data: String.to_charlist(data)}\n    Rclex.Msg.set(msg, msg_struct, 'StdMsgs.Msg.String')\n\n    # This sleep is essential for now, see Issue #212\n    Process.sleep(100)\n\n    IO.puts(\"Rclex: Publishing: #{data}\")\n    Rclex.Publisher.publish([publisher], [msg])\n\n    Rclex.Node.finish_job(publisher)\n    Rclex.ResourceServer.finish_node(node)\n    Rclex.shutdown(context)\n  end\nend\n```\n\nPlease also check the examples for Rclex.\n- [rclex/rclex_examples](https://github.com/rclex/rclex_examples)\n- [b5g-ex/rclex_on_nerves](https://github.com/b5g-ex/rclex_on_nerves)\n\n#","ref":"use_on_nerves.html#write-rclex-code","title":"Write Rclex code - Use on Nerves","type":"extras"},{"doc":"```\nmix firmware\nmix burn # or, mix upload\n```\n\n#","ref":"use_on_nerves.html#create-fw-and-burn-or-upload","title":"Create fw, and burn (or, upload) - Use on Nerves","type":"extras"},{"doc":"Connect the Nerves device via ssh.\n\n```\nssh nerves.local\n```\n\nOperate the following command on IEx.\n\n```\niex()> RclexUsageOnNerves.publish_message\nRclex: Publishing: Hello World from Rclex!\n{:ok, #Reference }\n```\n\nYou can confirm the above operation by subscribing with `ros2 topic echo` on the machine where ROS 2 env has been installed.\n\n```\n$ source /opt/ros/humble/setup.bash\n$ ros2 topic echo /chatter std_msgs/msg/String\ndata: Hello World from Rclex!\n---\n```","ref":"use_on_nerves.html#execute","title":"Execute - Use on Nerves","type":"extras"},{"doc":"# CHANGELOG","ref":"changelog.html","title":"CHANGELOG","type":"extras"},{"doc":"**Full Changelog**: https://github.com/rclex/rclex/compare/v0.8.5...v0.9.0\n\n* New features:\n  * Support Humble (and format with Elixir 1.15.5) by @pojiro in https://github.com/rclex/rclex/pull/241\n  * Support humble, galactic Nerves by @pojiro in https://github.com/rclex/rclex/pull/244\n  * change the recommended environment and versions by @takasehideki in https://github.com/rclex/rclex/pull/247\n  * Add humble support to arm32v7_ros_distros by @pojiro in https://github.com/rclex/rclex/pull/248\n* Code Improvements/Fixes:\n  * Fix bug of `mix rclex.gen.msgs` by @pojiro in https://github.com/rclex/rclex/pull/236\n  * fix docs about ROS_DISTRO from `foxy` to `humble` by @takasehideki in https://github.com/rclex/rclex/pull/249\n* Bumps:\n  * Bump ex_doc from 0.29.4 to 0.30.6 by @dependabot in https://github.com/rclex/rclex/pull/234 https://github.com/rclex/rclex/pull/237 https://github.com/rclex/rclex/pull/238\n  * Bump dialyxir from 1.3.0 to 1.4.1 by @dependabot in https://github.com/rclex/rclex/pull/240\n  * Bump mix_test_watch from 1.1.0 to 1.1.1 by @dependabot in https://github.com/rclex/rclex/pull/242\n* Known issues to be addressed in the near future:\n  * Lock `git_hooks` to 0.6.5 due to its issue in https://github.com/rclex/rclex/issues/138\n  * Release rcl nif resources when GerServer terminates in https://github.com/rclex/rclex/issues/160\n  * `publish/2` sometimes failed just after `create_publisher/3` in https://github.com/rclex/rclex/issues/212\n  * CI fails randomly at mix test in https://github.com/rclex/rclex/issues/246\n  * Bump to Iron Irwini in https://github.com/rclex/rclex/issues/228\n* Note in this release:\n  * Please welcome Humble Hawksbill (and Galactic Geochelone) as the new supported distribution for Rclex!! :tada:","ref":"changelog.html#v0-9-0-on-11-sep-2023","title":"v0.9.0 on 11 Sep 2023 - CHANGELOG","type":"extras"},{"doc":"**Full Changelog**: https://github.com/rclex/rclex/compare/v0.8.4...v0.8.5\n\n* New features:\n  * Adding handling for nested Message types from different Packages by @steve-at in https://github.com/rclex/rclex/pull/230\n* Code Improvements/Fixes: none\n* Bumps:\n  * Bump elixir_make from 0.7.6 to 0.7.7\n* Known issues to be addressed in the near future:\n  * `publish/2` sometimes failed just after `create_publisher/3` in https://github.com/rclex/rclex/issues/212\n  * Lock `git_hooks` to 0.6.5 due to its issue in https://github.com/rclex/rclex/issues/138\n  * Bump to Humble Hawksbill in https://github.com/rclex/rclex/issues/114\n  * Bump to Iron Irwini in https://github.com/rclex/rclex/issues/228\n  * Release rcl nif resources when GerServer terminates in https://github.com/rclex/rclex/issues/160\n* Note in this release: none","ref":"changelog.html#v0-8-5-on-05-jun-2023","title":"v0.8.5 on 05 Jun 2023 - CHANGELOG","type":"extras"},{"doc":"**Full Changelog**: https://github.com/rclex/rclex/compare/v0.8.3...v0.8.4\n\n* New features: none\n* Code Improvements/Fixes:\n  * Fix typos by @kianmeng in https://github.com/rclex/rclex/pull/217\n* Bumps:\n  * Bump elixir_make from 0.7.1 to 0.7.6\n  * Bump ex_doc from 0.29.1 to 0.29.4\n  * Bump credo from 1.6.7 to 1.7.0\n  * Bump dialyxir from 1.2.0 to 1.3.0\n* Known issues to be addressed in the near future:\n  * `publish/2` sometimes failed just after `create_publisher/3` in https://github.com/rclex/rclex/issues/212\n  * Lock `git_hooks` to 0.6.5 due to its issue in https://github.com/rclex/rclex/issues/138\n  * Bump to Humble Hawksbill in https://github.com/rclex/rclex/issues/114\n  * Release rcl nif resources when GerServer terminates in https://github.com/rclex/rclex/issues/160\n* Note in this release: none","ref":"changelog.html#v0-8-4-on-11-apr-2023","title":"v0.8.4 on 11 Apr 2023 - CHANGELOG","type":"extras"},{"doc":"**Full Changelog**: https://github.com/rclex/rclex/compare/v0.8.2...v0.8.3\n\n* New features:\n  * Add arm32v7 support to mix rclex.prep.ros2 by @pojiro in https://github.com/rclex/rclex/pull/210\n* Code Improvements/Fixes:\n  * improve doc about docker env by @takasehideki in https://github.com/rclex/rclex/pull/208\n  * Remove useless gitignore line by @pojiro in https://github.com/rclex/rclex/pull/211\n  * insert sleep before publishing on example code (see #212) by @takasehideki in https://github.com/rclex/rclex/pull/213\n* Bumps:\n  * Bump elixir_make from 0.7.0 to 0.7.1 by @dependabot in https://github.com/rclex/rclex/pull/209\n* Known issues to be addressed in the near future:\n  * `publish/2` sometimes failed just after `create_publisher/3` in https://github.com/rclex/rclex/issues/212\n  * Lock `git_hooks` to 0.6.5 due to its issue in https://github.com/rclex/rclex/issues/138\n  * Bump to Humble Hawksbill in https://github.com/rclex/rclex/issues/114\n  * Release rcl nif resources when GerServer terminates in https://github.com/rclex/rclex/issues/160\n* Note in this release: none","ref":"changelog.html#v0-8-3-on-12-dec-2022","title":"v0.8.3 on 12 Dec 2022 - CHANGELOG","type":"extras"},{"doc":"**Full Changelog**: https://github.com/rclex/rclex/compare/v0.8.1...v0.8.2\n\n* New features: none\n* Code Improvements/Fixes:\n  * fix to check ROS_DIR by @takasehideki in https://github.com/rclex/rclex/pull/206\n* Bumps: none\n* Known issues to be addressed in the near future:\n  * Lock `git_hooks` to 0.6.5 due to its issue in https://github.com/rclex/rclex/issues/138\n  * Bump to Humble Hawksbill in https://github.com/rclex/rclex/issues/114\n  * Release rcl nif resources when GerServer terminates in https://github.com/rclex/rclex/issues/160\n* Note in this release:\n  * This release only fixes a critical issue that existed in the previous release,,,","ref":"changelog.html#v0-8-2-on-03-dec-2022","title":"v0.8.2 on 03 Dec 2022 - CHANGELOG","type":"extras"},{"doc":"**Full Changelog**: https://github.com/rclex/rclex/compare/v0.8.0...v0.8.1\n\n* New features:\n  * Create docs for Use on Nerves and improve related mix tasks by @pojiro in https://github.com/rclex/rclex/pull/198\n* Code Improvements/Fixes:\n  * Change `raise` to `Mix.raise` to proper mix task error handling by @pojiro in https://github.com/rclex/rclex/pull/194\n  * Change Makefile's if statement to confirm ROS_DIR exists by @pojiro in https://github.com/rclex/rclex/pull/195\n  * Improve mix tasks usability by @pojiro in https://github.com/rclex/rclex/pull/196\n* Bumps:\n  * Bump ex_doc from 0.29.0 to 0.29.1 by @dependabot in https://github.com/rclex/rclex/pull/199\n  * Bump elixir_make from 0.6.3 to 0.7.0 by @dependabot in https://github.com/rclex/rclex/pull/200\n* Known issues to be addressed in the near future:\n  * Lock `git_hooks` to 0.6.5 due to its issue in https://github.com/rclex/rclex/issues/138\n  * Bump to Humble Hawksbill in https://github.com/rclex/rclex/issues/114\n  * Release rcl nif resources when GerServer terminates in https://github.com/rclex/rclex/issues/160\n* Note in this release: none","ref":"changelog.html#v0-8-1-on-03-dec-2022","title":"v0.8.1 on 03 Dec 2022 - CHANGELOG","type":"extras"},{"doc":"**Full Changelog**: https://github.com/rclex/rclex/compare/v0.7.2...v0.8.0\n\n**Holy Shit! Rclex now works on Nerves as well!!** :tada:\n\n* New features:\n  * Refactor generate messages codes pojiro by @pojiro in https://github.com/rclex/rclex/pull/185\n  * refactor Makefile and msgs.ex by @pojiro in https://github.com/rclex/rclex/pull/192\n  * Feature add tasks to prepare ros2 resources by @pojiro in https://github.com/rclex/rclex/pull/190\n* Code Improvements/Fixes:\n  * Add docker command to mix test.watch section on README.md by @pojiro in https://github.com/rclex/rclex/pull/177\n  * Fix `mix deps.get` error on GitHub Actions by @s-hosoai in https://github.com/rclex/rclex/pull/178\n  * Fix multiple definition by @pojiro in https://github.com/rclex/rclex/pull/182\n  * Remove DASHING support from c source by @pojiro in https://github.com/rclex/rclex/pull/189\n  * Remove unused rclex_gen_msgs from mix.lock by @pojiro in https://github.com/rclex/rclex/pull/191\n* Bumps:\n  *  `ex_doc` from 0.28.6 to 0.29.0 by @dependabot in https://github.com/rclex/rclex/pull/184\n* Known issues to be addressed in the near future:\n  * Lock `git_hooks` to 0.6.5 due to its issue in https://github.com/rclex/rclex/issues/138\n  * Bump to Humble Hawksbill in https://github.com/rclex/rclex/issues/114\n  * Release rcl nif resources when GerServer terminates in https://github.com/rclex/rclex/issues/160\n* Note in this release:\n  * set supported/tested elixir version to above 1.12 by @takasehideki in https://github.com/rclex/rclex/pull/186","ref":"changelog.html#v0-8-0-on-01-nov-2022","title":"v0.8.0 on 01 Nov 2022 - CHANGELOG","type":"extras"},{"doc":"**Full Changelog**: https://github.com/rclex/rclex/compare/v0.7.1...v0.7.2\n\n* New features: none\n* Code Improvements/Fixes:\n  * change the recommended env and target versions for GitHub Actions CI by @takasehideki in https://github.com/rclex/rclex/pull/173\n  * Enable Dialyzer on GitHub Actions (remove uncheck and ignore exit options) by @s-hosoai in https://github.com/rclex/rclex/pull/165\n  * elinimate errors in `mix dialyzer` on GHA (fix #174) by @takasehideki in https://github.com/rclex/rclex/pull/175\n* Bumps:\n  * `dialyxir` from 1.1.0 to 1.2.0 in https://github.com/rclex/rclex/pull/166\n  *  `ex_doc` from 0.28.4 to 0.28.5 in https://github.com/rclex/rclex/pull/168\n  * `credo` from 1.6.5 to 1.6.7 by https://github.com/rclex/rclex/pull/169\n* Known issues to be addressed in the near future:\n  * Lock `git_hooks` to 0.6.5 due to its issue in https://github.com/rclex/rclex/issues/138\n  * Bump to Humble Hawksbill in https://github.com/rclex/rclex/issues/114\n  * Release rcl nif resources when GerServer terminates in https://github.com/rclex/rclex/issues/160\n* Note in this release:\n  * The recommended environment is changed to the following versions\n    * Ubuntu 20.04.2 LTS (Focal Fossa)\n    * ROS 2 [Foxy Fitzroy](https://docs.ros.org/en/foxy/Releases/Release-Foxy-Fitzroy.html)\n    * Elixir 1.13.4-otp-25\n    * Erlang/OTP 25.0.3","ref":"changelog.html#v0-7-2-on-22-sep-2022","title":"v0.7.2 on 22 Sep 2022 - CHANGELOG","type":"extras"},{"doc":"**Full Changelog**: https://github.com/rclex/rclex/compare/v0.7.0...v0.7.1\n\n* New Contributors: @pojiro :tada:\n* New features:\n  * Improve unit test environment on local dev machine by @pojiro in https://github.com/rclex/rclex/pull/131\n* Code Improvements/Fixes:\n  * Enrich doc and specs with the awesome contributions by @pojiro (e.g., in https://github.com/rclex/rclex/pull/121)\n  * Enrich unit tests with the awesome contributions by @pojiro (e.g., in https://github.com/rclex/rclex/pull/136)\n  * Improve credo config, .credo.exs by @pojiro in https://github.com/rclex/rclex/pull/120\n  * exclude auto-generated files format by @pojiro in https://github.com/rclex/rclex/pull/135\n  * refactor Rclex.ResourceServer.call_nifs_rcl_node_init/5 by @pojiro in https://github.com/rclex/rclex/pull/147\n  * fix node name bug, when it attributes a namespace (and also fix #142) by @pojiro in https://github.com/rclex/rclex/pull/149\n  * Remove KeepSub module which is unused (also fix dialyzer error) by @s-hosoai in https://github.com/rclex/rclex/pull/164\n  * Improve README by @takasehideki in https://github.com/rclex/rclex/pull/171\n* Bumps:\n  * `credo` from 1.6.4 to 1.6.5 in https://github.com/rclex/rclex/pull/162\n* Known issues to be addressed in the near future:\n  * Lock `git_hooks` to 0.6.5 due to its issue in https://github.com/rclex/rclex/issues/138\n  * Bump to Humble Hawksbill in https://github.com/rclex/rclex/issues/114\n  * Release rcl nif resources when GerServer terminates in https://github.com/rclex/rclex/issues/160\n* Note in this release:\n  * After long consideration, we have decided to end the support for Dashing as the target environment 6ae367d","ref":"changelog.html#v0-7-1-on-21-sep-2022","title":"v0.7.1 on 21 Sep 2022 - CHANGELOG","type":"extras"},{"doc":"* New features: none\n* Code Improvements/Fixes:\n  * Refactoring to simplify implementation by @s-hosoai in https://github.com/rclex/rclex/pull/118\n    * rename and simplify functions\n    * delete comment out functions\n    * change NIF exception handling\n    * add @spac and @impl\n    * refine tests\n* Bumps: none\n* Known issues:\n  * `rclex_connection_tests` becomes failed on Dashing from v0.6.0_rc #89\n  * `Rclex.initialize_msg/0` is undefined or private in `KeepSub.sub_task_start/2` #104\n* Full Changelog: https://github.com/rclex/rclex/compare/v0.6.2...v0.7.0","ref":"changelog.html#v0-7-0-on-27-may-2022","title":"v0.7.0 on 27 May 2022 - CHANGELOG","type":"extras"},{"doc":"* Please welcome @s-hosoai as a new maintainer!\n* New features: none\n* Code Improvements/Fixes:\n  * Add simple pub sub test by @s-hosoai in https://github.com/rclex/rclex/pull/113\n  * fix job_queue length condition (fix #112) by @s-hosoai in https://github.com/rclex/rclex/pull/115\n  * remove Dashing from CI targets by @takasehideki in https://github.com/rclex/rclex/pull/116\n* Bumps:\n  * `ex_doc` to 0.28.4 #110\n* Known issues:\n  * `rclex_connection_tests` becomes failed on Dashing from v0.6.0_rc #89\n  * `Rclex.initialize_msg/0` is undefined or private in `KeepSub.sub_task_start/2` #104\n* Full Changelog: https://github.com/rclex/rclex/compare/v0.6.1...v0.6.2","ref":"changelog.html#v0-6-2-on-25-may-2022","title":"v0.6.2 on 25 May 2022 - CHANGELOG","type":"extras"},{"doc":"- New features: none\n- Code Improvements/Fixes:\n  - include packages.txt and template file to hex package #107\n- Bumps: none\n- Known issues:\n  - `rclex_connection_tests` becomes failed on Dashing from v0.6.0_rc #89\n  - `Rclex.initialize_msg/0` is undefined or private in `KeepSub.sub_task_start/2` #104\n- Full Changelog: https://github.com/rclex/rclex/compare/v0.6.0...v0.6.1","ref":"changelog.html#v0-6-1-on-22-mar-2022","title":"v0.6.1 on 22 Mar 2022 - CHANGELOG","type":"extras"},{"doc":"- New features:\n  - support custom msgtype!! #87 #98\n- Code Improvements/Fixes:\n  - Enhance README #102\n- Bumps:\n  - `ex_doc` to 0.28.2 #99\n  - `credo` to 1.6.4 #100\n- Known issues:\n  - `rclex_connection_tests` becomes failed on Dashing from v0.6.0_rc #89\n  - `Rclex.initialize_msg/0` is undefined or private in `KeepSub.sub_task_start/2` #104\n- Full Changelog: https://github.com/rclex/rclex/compare/v0.5.3...v0.6.0","ref":"changelog.html#v0-6-0-on-17-mar-2022","title":"v0.6.0 on 17 Mar 2022 - CHANGELOG","type":"extras"},{"doc":"- New features:\n  - Add following APIs #92 \n    - `create_singlenode_with_executor_setting/3`\n      - can specify `executor_setting` in addition to args in `create_singlenode/3`\n      - `{queue_length}` means the maximum length of `job_queue` under the created nodes\n      - `change_order` (in `{queue_length, change_order}`) means a function that adjusts the execution order of `job_exe`\n    - `create_nodes_with_executor_setting/4`, `create_timer_with_executor_setting/5` and `create_timer_with_executor_setting/6`: same with the above\n- Code Improvements/Fixes: none\n- Bumps:\n  - `ex_doc` to 0.28.1 #96\n  - `credo` to 1.6.3 #91\n- Known issues:\n  - `mix test` sometimes fails, but we don't think it will affect the behavior #68\n- Full Changelog: https://github.com/rclex/rclex/compare/v0.5.2...v0.5.3","ref":"changelog.html#v0-5-3-on-22-feb-2022","title":"v0.5.3 on 22 Feb 2022 - CHANGELOG","type":"extras"},{"doc":"- New features:\n  - Add timer name in args of `create_timer/4` and `create_timer/5` to treat timer ID ddf99cf\n  - Implement `ResourceServer` module #83\n    - `JobExecutor` and `JobQueue` will be created for each node and timer\n    - `Executor` has been obsoleted and changed to the above feature\n- Code Improvements/Fixes:\n  - change wait time 50 to 5 milliseconds #76\n  - change docker tags for CI test #78\n- Bumps:\n  - `ex_doc` to 0.27.3 #80\n  - `credo` to 1.6.2 #82\n- Known issues:\n  - `mix test` sometimes fails, but we don't think it will affect the behavior #68\n- Full Changelog: https://github.com/rclex/rclex/compare/v0.5.1...v0.5.2","ref":"changelog.html#v0-5-2-on-21-jan-2022","title":"v0.5.2 on 21 Jan 2022 - CHANGELOG","type":"extras"},{"doc":"- New features:\n  - Implement `Timer.terminate/2` [2915de5](https://github.com/rclex/rclex/commit/2915de5a7bdaa3ca22b56c7900d03a9931e057f9)\n- Code Improvements/Fixes:\n  - Change filename to snake_case according to follow ElixirStyleGuide #72 \n  - Some minor refactoring to remove boring warning in `mix compile` #73\n- Bumps:\n  - `ex_doc` to 0.26.0 #71\n  - `credo` to 1.6.1 #70\n- Known issues:\n  - `mix test` sometimes fails, but we don't think it will affect the behavior #68\n- Full Changelog: https://github.com/rclex/rclex/compare/v0.5.0...v0.5.1","ref":"changelog.html#v0-5-1-on-30-nov-2021","title":"v0.5.1 on 30 Nov 2021 - CHANGELOG","type":"extras"},{"doc":"- New features:\n  - Implement `Executor` module by using GenServer #61 #67\n- Code Improvements/Fixes:\n  - Hide NIF functions from users #54 #55\n- Bumps:\n  - `ex_doc` to 0.25.5 #63\n  - `elixir_make` to 0.6.3 #62\n- Known issues:\n  - `mix test` sometimes fails, but we don't think it will affect the behavior #68\n- Full Changelog: https://github.com/rclex/rclex/compare/v0.4.1...v0.5.0","ref":"changelog.html#v0-5-0-on-01-nov-2021","title":"v0.5.0 on 01 Nov 2021 - CHANGELOG","type":"extras"},{"doc":"- New features:\n  - Implement `rcl_node_get_name/1` and `rcl_get_topic_names_and_types/3` #42\n- Code Improvements/Fixes:\n  - Improve code according to the advice from Credo #41 \n  - Use DEBUG_PRINTF and Logger to control print message in library #46 #23 #24\n  - Change the method to obtain ROS_DIR with `which ros2` #38\n  - Add and apply Artistic Style for C source (mix format) #45\n- Enhancements:\n  - Introduce `mix credo` on GHA #48\n  - Create GHA to publish to Hex when tags released #40\n  - Separate ci.yml #49\n  - Improve timing of connection tests [rclex/rclex_connection_tests#12](https://github.com/rclex/rclex_connection_tests/pull/12)\n- Bumps:\n  - `ex_doc` from 0.24.2 to 0.25.0 #47\n- Full Changelog: https://github.com/rclex/rclex/compare/v0.4.0...v0.4.1","ref":"changelog.html#v0-4-1-on-24-jul-2021","title":"v0.4.1 on 24 Jul 2021 - CHANGELOG","type":"extras"},{"doc":"- Please welcome @kebus426 as a new maintainer! \n- Support for [ROS 2 Foxy Fitzroy](https://index.ros.org/doc/ros2/Releases/Release-Foxy-Fitzroy/)!! #32 :tada:\n- Recommended environment is now Ubuntu 20.04.2 LTS / ROS 2 Foxy / Elixir 1.11.2-otp-23 / Erlang/OTP 23.3.1\n  - also work well on Ubuntu 18.04.5 LTS and Dashing Diademata\n- Introduce automatic test a.k.a CI works on [GitHub Actions](https://github.com/rclex/rclex/actions) #13 #25 #31 \n  - Please also check [rclex_connection_tests](https://github.com/rclex/rclex_connection_tests) and [rclex_docker on Docker Hub](https://hub.docker.com/r/rclex/rclex_docker) for more details\n  - Note that CI sometimes fails due to the performance of GHA runner #28 \n- Implement subsucribe_stop/2 #30\n- Fix bug on timer_loop/4 #29 #21 \n- Create [rclex Organization](https://github.com/rclex) and change source URL #18\n- Full Changelog: https://github.com/rclex/rclex/compare/v0.3.1...v0.4.0","ref":"changelog.html#v0-4-0-on-8-jun-2021","title":"v0.4.0 on 8 Jun 2021 - CHANGELOG","type":"extras"},{"doc":"- Translate README from Japanese to English #11","ref":"changelog.html#v0-3-1-on-4-jul-2020","title":"v0.3.1 on 4 Jul 2020 - CHANGELOG","type":"extras"},{"doc":"- Change module name to Rclex #8","ref":"changelog.html#v0-3-0-on-26-jun-2020","title":"v0.3.0 on 26 Jun 2020 - CHANGELOG","type":"extras"},{"doc":"- Publish this package on hex.pm\n  - You can now use this repository as the Hex package\n- Refactor source tree\n  - Adjust elixir_make to generate rclex.so to priv/\n  - Eliminate Timex\n- Apply mix format\n- Write README doc, only by Japanese (sorry,,,)","ref":"changelog.html#v0-2-0-on-24-feb-2020","title":"v0.2.0 on 24 Feb 2020 - CHANGELOG","type":"extras"},{"doc":"First publication","ref":"changelog.html#v0-1-0-on-24-feb-2020","title":"v0.1.0 on 24 Feb 2020 - CHANGELOG","type":"extras"}]}